﻿using System;
using System.Windows.Forms;


namespace CaesarCipher
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            KeyBox.Text = "B";
        }

        private void PlainTextBox_TextChanged(object sender, EventArgs e)
        {
            if (!Updating)
            {
                Updating = true;
                CipherTextBox.Text = "";
                Updating = false;
            }
        }

        private void CipherTextBox_TextChanged(object sender, EventArgs e)
        {
            if (!Updating)
            {
                Updating = true;
                PlainTextBox.Text = "";
                Updating = false;
            }
        }

        private void EncryptButton_Click(object sender, EventArgs e)
        {
            if (!Updating)
            {
                Updating = true;

                int Key = (int)(KeyBox.Text[0]);
                Key -= (int)'A';

                string PlainText = PlainTextBox.Text;
                PlainText = PlainText.Trim();
                PlainText = PlainText.ToLower();

                string CipherText = "";
                for (int CharNum = 0; CharNum < PlainText.Length; CharNum++)
                {
                    char PlainTextChar = PlainText[CharNum];
                    if (char.IsLetter(PlainTextChar))
                    {
                        int CharIndex = (int)PlainTextChar;
                        CharIndex -= (int)'a';
                        CharIndex += Key;
                        if (CharIndex >= 26)
                        {
                            CharIndex -= 26;
                        }
                        CharIndex += (int)'A';
                        char CipherTextChar = (char)CharIndex;
                        CipherText += CipherTextChar;
                    }
                    else
                    {
                        CipherText += PlainTextChar;
                    }
                }

                PlainTextBox.Text = PlainText;
                CipherTextBox.Text = CipherText;

                Updating = false;
            }
        }

        private void DecryptButton_Click(object sender, EventArgs e)
        {
            if (!Updating)
            {
                Updating = true;

                int Key = (int)(KeyBox.Text[0]);
                Key -= (int)'A';

                string CipherText = CipherTextBox.Text;
                CipherText = CipherText.Trim();
                CipherText = CipherText.ToUpper();

                string PlainText = "";
                for (int CharNum = 0; CharNum < CipherText.Length; CharNum++)
                {
                    char CipherTextChar = CipherText[CharNum];
                    if (char.IsLetter(CipherTextChar))
                    {
                        int CharIndex = (int)CipherTextChar;
                        CharIndex -= (int)'A';
                        CharIndex -= Key;
                        if (CharIndex < 0)
                        {
                            CharIndex += 26;
                        }
                        CharIndex += (int)'a';
                        char PlainTextChar = (char)CharIndex;
                        PlainText += PlainTextChar;
                    }
                    else
                    {
                        PlainText += CipherTextChar;
                    }
                }

                PlainTextBox.Text = PlainText;
                CipherTextBox.Text = CipherText;

                Updating = false;
            }
        }

        private bool Updating = false;
    }
}
