﻿using System;
using System.Security.Cryptography;
using System.Text;
using System.Windows.Forms;


namespace DigitalSignatures
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            TheMessageBox.Text = "Transfer ONE MILLION POUNDS to bank account 007 immediately. M.";
        }

        private void GenerateKeysButton_Click(object sender, EventArgs e)
        {
            RSACryptoServiceProvider RSACSP = new RSACryptoServiceProvider();

            byte[] PrivateKey = RSACSP.ExportCspBlob(true);
            PrivateKeyBox.Text = Convert.ToBase64String(PrivateKey);

            byte[] PublicKey = RSACSP.ExportCspBlob(false);
            PublicKeyBox.Text = Convert.ToBase64String(PublicKey);
        }

        private void SignButton_Click(object sender, EventArgs e)
        {
            RSACryptoServiceProvider RSACSP = new RSACryptoServiceProvider();

            byte[] PrivateKey = Convert.FromBase64String(PrivateKeyBox.Text);
            RSACSP.ImportCspBlob(PrivateKey);

            SHA512CryptoServiceProvider SHA512CSP = new SHA512CryptoServiceProvider();

            string TheMessage = TheMessageBox.Text;
            byte[] TheMessageBytes = Encoding.ASCII.GetBytes(TheMessage);
            byte[] TheMessageHash = SHA512CSP.ComputeHash(TheMessageBytes);
            MessageHashBox.Text = Convert.ToBase64String(TheMessageHash);

            byte[] Signature = RSACSP.SignHash(TheMessageHash, CryptoConfig.MapNameToOID("SHA512"));
            SignatureBox.Text = Convert.ToBase64String(Signature);
        }

        private void VerifySignatureButton_Click(object sender, EventArgs e)
        {
            RSACryptoServiceProvider RSACSP = new RSACryptoServiceProvider();

            byte[] PublicKey = Convert.FromBase64String(PublicKeyBox.Text);
            RSACSP.ImportCspBlob(PublicKey);

            SHA512CryptoServiceProvider SHA512CSP = new SHA512CryptoServiceProvider();

            string TheMessage = TheMessageBox.Text;
            byte[] TheMessageBytes = Encoding.ASCII.GetBytes(TheMessage);
            byte[] TheMessageHash = SHA512CSP.ComputeHash(TheMessageBytes);

            byte[] Signature = Convert.FromBase64String(SignatureBox.Text);
            VerifiedBox.Checked = RSACSP.VerifyHash(TheMessageHash, CryptoConfig.MapNameToOID("SHA512"), Signature);
        }
    }
}
