﻿using System;
using System.Windows.Forms;


namespace Primes
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void RunButton_Click(object sender, EventArgs e)
        {
            int PrimesRequired = Convert.ToInt32(PrimesRequiredBox.Text);
            int[] Primes = new int[PrimesRequired + 1];
            int PrimeCount = 0;

            DateTime StartTime = DateTime.UtcNow;

            Primes[PrimeCount++] = 2;
            Primes[PrimeCount++] = 3;
            Primes[PrimeCount++] = 5;

            int N = 11;
            while (PrimeCount < PrimesRequired)
            {
                int Index = 2;
                bool PossiblePrimeA = true;
                bool PossiblePrimeB = true;
                while (PossiblePrimeA || PossiblePrimeB)
                {
                    int Prime = Primes[Index++];
                    if (Prime * Prime > N)
                    {
                        break;
                    }

                    int Remainder = N % Prime;
                    if (Remainder == 0)
                    {
                        PossiblePrimeB = false;
                    }
                    else if (Remainder == 4)
                    {
                        PossiblePrimeA = false;
                    }
                }

                if (PossiblePrimeA)
                {
                    Primes[PrimeCount++] = N - 4;
                }

                if (PossiblePrimeB)
                {
                    Primes[PrimeCount++] = N;
                }

                N += 6;
            }

            DateTime EndTime = DateTime.UtcNow;

            TimeSpan TimeTaken = EndTime - StartTime;

            string Text = "Prime " + PrimesRequired.ToString("#,##0") + " = " + Primes[PrimesRequired - 1].ToString("#,##0");
            Text += "\n";
            Text += "Time taken : " + TimeTaken.TotalMilliseconds.ToString("#,##0") + " msec";
            MessageBox.Show(Text);
        }
    }
}
